#define USE_ARDUINO_INTERRUPTS true    // Set-up low-level interrupts for most acurate BPM math.
#include <Stepper.h>
#include <PulseSensorPlayground.h>

const int PulseWire = 0; // Sensor input
const int stepsPerRevolution = 1025;  // change this to fit the number of steps per meter face for my motor
int Threshold = 550;           // Determine which Signal to "count as a beat" and which to ignore.
int testing = 0;
int oldBPM = 0;
int newBPM = 0;
const int division = 7;
int steps = 0;
int differenceSteps = 0;

PulseSensorPlayground pulseSensor;  // Creates an instance of the PulseSensorPlayground object called "pulseSensor"
Stepper stepper(stepsPerRevolution, 8, 10,9,11); // initialize the stepper library on pins 8 through 11:

void setup() {
  stepper.setSpeed(30);    // set the speed at 30 rpm:   
  Serial.begin(9600);   // initialize the serial port:
  pulseSensor.analogInput(PulseWire);
  stepper.step(-1024);
}

void loop() {
  int myBPM = pulseSensor.getBeatsPerMinute();  // Calls function on our pulseSensor object that returns BPM as an "int".                                         
  steps = (myBPM - 50) * division;
  differenceSteps = (steps - testing);
  
  if (myBPM < 51)  {
        stepper.step(0);
        Serial.println(" off");
        Serial.println(myBPM);  
  }else if (myBPM > newBPM) {
        stepper.step(differenceSteps);
        Serial.println(" UP");
        Serial.println(myBPM);
  }else if (myBPM < newBPM) {
        stepper.step(-differenceSteps);
        Serial.println(" DOWN");
        Serial.println(myBPM);
 }
  newBPM = myBPM;
  testing = (myBPM - 50) * division;     
  delay(20);
}
